
;;;;;;;;;;; test menu ;;;;;;;;;;;;;;;;;;;;
;;;; "Perform Top Level Process for PC Configuration" ?customer ?requirement_id ?user_requirements ?processor ?slot1 ?disk_controller ?slot2 ?io ?slot3 ?additional_device ?slot_list ?spec_id ?tech_constraints ?cost_constraints ?total_cost

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(refinement perform_top_level_process_for_PC_configuration 
           ("Perform Top Level Process for PC Configuration"
                             ?customer 
                             ?requirement_id    ?user_requirements 
                             ?processor         ?slot1
                             ?disk_controller   ?slot2
                             ?io                ?slot3
                             ?additional_device ?slot_list
                             ?spec_id           
                             ?tech_constraints ?cost_constraints
                             ?total_cost )
  
  (nodes
    (1 ("Obtain Requirements for PC Configuration"       ?requirement_id         ?user_requirements 
                                                         ?additional_device ))
      
    (2 ("Determine Processor"                            ?requirement_id         ?user_requirements 
                                                         ?processor              ?slot1
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost ))

    (3 ("Determine Disk Controller"                      ?requirement_id         ?user_requirements 
                                                         ?disk_controller        ?slot2     
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost ))

    (4 ("Determine IO Boards"                            ?requirement_id         ?user_requirements 
                                                         ?io                     ?slot3     
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost ))

    (5 ("Determine Specification for Other Preferences"  ?requirement_id         ?user_requirements 
                                                         ?additional_device      ?slot_list 
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost ))

    (6 ("Examine PC Specification"                       ?customer 
                                                         ?requirement_id    ?user_requirements 
                                                         ?processor         ?slot1
                                                         ?disk_controller   ?slot2
                                                         ?io                ?slot3
                                                         ?additional_device ?slot_list
                                                         ?spec_id           
                                                         ?tech_constraints ?cost_constraints
                                                         ?total_cost  ))

    (7 ("Provide Customer the Configuration"             ?customer 
                                                         ?requirement_id         ?user_requirements 
                                                         ?processor              ?slot1
                                                         ?disk_controller        ?slot2
                                                         ?io                     ?slot3
                                                         ?additional_device      ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost ))
  )
  (orderings
    (1 2) (1 3) (1 4)(1 5)((2 3 4 5) 6) (6 7) )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement  examine_PC_specification_repeat  ("Examine PC Specification"     ?customer
                                                         ?requirement_id         ?users_requirements 
                                                         ?processor              ?slot1
                                                         ?disk_controller        ?slot2
                                                         ?io                     ?slot3
                                                         ?additional_device      ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost )

  
 (nodes
    (1 ("Perform Top Level Process for PC Configuration"
                                                         ?customer
                                                         ?requirement_id     ?user_requirements 
                                                         ?processor         ?slot1
                                                         ?disk_controller   ?slot2
                                                         ?io                ?slot3
                                                         ?additional_device ?slot_list
                                                         ?spec_id           
                                                         ?tech_constraints ?cost_constraints
                                                         ?total_cost ))
))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement determine_processor                      ("Determine Processor"
                                                         ?requirement_id         ?user_requirements 
                                                         ?processor              ?slot1
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost)
  (nodes 
    (1 ("Determine Constraint and Domain for device"     ?requirement_id         ?user_requirements 
                                                         ?processor              ?slot1
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost))

    (2 ("Confirm With Cost Constraints"                  ?requirement_id         ?user_requirements 
                                                         ?processor            
                                                         ?spec_id   
                                                         ?cost_constraints       ?total_cost)) 
 
    (3 ("Confirm With Technical Constraints"             ?requirement_id         ?user_requirements 
                                                         ?processor              ?slot1
                                                         ?spec_id      
                                                         ?tech_constraints ))

    (4 ("Check Cost Constraints"                         ?requirement_id         ?user_requirements 
                                                         ?processor              
                                                         ?spec_id      
                                                         ?cost_constraints
                                                         ?total_cost))
  )
  (orderings (1 2) (1 3) ((2 3) 4 ))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement determine_disk_controller
                                 ("Determine Disk Controller"
                                                         ?requirement_id         ?user_requirements 
                                                         ?disk_controller        ?slot2
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost)
  (nodes 
    (1 ("Determine Constraint and Domain for device"     ?requirement_id         ?user_requirements 
                                                         ?disk_controller        ?slot2
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost))

    (2 ("Confirm With Cost Constraints"                  ?requirement_id         ?user_requirements 
                                                         ?disk_controller        ?slot2
                                                         ?spec_id   
                                                         ?cost_constraints       ?total_cost)) 
 
    (3 ("Confirm With Technical Constraints"             ?requirement_id         ?user_requirements 
                                                         ?disk_controller        ?slot2
                                                         ?spec_id      
                                                         ?tech_constraints ))

    (4 ("Check Cost Constraints"                         ?requirement_id         ?user_requirements 
                                                         ?processor              
                                                         ?spec_id      
                                                         ?cost_constraints
                                                         ?total_cost))
  )
  (orderings (1 2) (1 3) ((2 3) 4 ) )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement determine_io_boards
                                 ("Determine IO Boards"  
                                                         ?requirement_id         ?user_requirements 
                                                         ?io                     ?slot3
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost)
  (nodes 
    (1 ("Determine Constraint and Domain for device"     ?requirement_id         ?user_requirements 
                                                         ?io                     ?slot3
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost))

    (2 ("Confirm With Cost Constraints"                  ?requirement_id         ?user_requirements 
                                                         ?io                     ?slot3
                                                         ?spec_id   
                                                         ?cost_constraints       ?total_cost)) 
 
    (3 ("Confirm With Technical Constraints"             ?requirement_id         ?user_requirements 
                                                         ?io                     ?slot3
                                                         ?spec_id      
                                                         ?tech_constraints ))

    (4 ("Check Cost Constraints"                         ?requirement_id         ?user_requirements 
                                                         ?io            
                                                         ?spec_id      
                                                         ?cost_constraints
                                                         ?total_cost))
  )
  (orderings (1 2) (1 3) ((2 3) 4 ) )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement determine_specification_for_other_preferences
                                               ("Determine Specification for Other Preferences"
                                                         ?requirement_id         ?user_requirements 
                                                         ?additional_device      ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost)
  (nodes 
    (1 ("Determine Constraint and Domain for device"     ?requirement_id         ?user_requirements 
                                                         ?additional_device      ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints       ?cost_constraints
                                                         ?total_cost))

    (2 ("Confirm With Cost Constraints"                  ?requirement_id         ?user_requirements 
                                                         ?additional_device      ?slot_list
                                                         ?spec_id   
                                                         ?cost_constraints       ?total_cost)) 
 
    (3 ("Confirm With Technical Constraints"             ?requirement_id         ?user_requirements 
                                                         ?additional_device      ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints ))

    (4 ("Check Cost Constraints"                         ?requirement_id         ?user_requirements 
                                                         ?additional_device            
                                                         ?spec_id      
                                                         ?cost_constraints
                                                         ?total_cost))
  )
  (orderings (1 2) (1 3) ((2 3) 4 ))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; communicatin processes 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(refinement confirm_with_technical_constraints
                               ("Confirm With Technical Constraints"             
                                                         ?requirement_id         ?user_requirements 
                                                         ?device                 ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints )
  (nodes 
    (1 (dispatch with report-back Technical Details for Device
                                                         ?requirement_id         ?user_requirements 
                                                         ?device                 ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints ))
    (2 (receive dispatched Technical Specification for Device
                                                         ?requirement_id         ?user_requirements 
                                                         ?device                 ?slot_list
                                                         ?spec_id      
                                                         ?tech_constraints ))
  )
  (orderings (1 2) )
)

;;;;;;;;;;;;;;;;;;;; end of file ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





















