/* Author: Jussi Stader
 * Date: 6/2/02
 * Copyright: (c) 2002, AIAI, University of Edinburgh
 */

package ix.iview.domain.event;

import java.util.EventObject;
import ix.iview.domain.*;

public class UIDomainEvent extends EventObject {

    protected UIObject object;

    public UIDomainEvent(UIDomain source, UIObject object) {
	super(source);
	this.object = object;
    }
    public UIDomainEvent(UIDomain source) {
	super(source);
    }

    public UIObject getObject() {
	return object;
    }
    public UIDomain getDomain() {
	return (UIDomain)getSource();
    }

}
