/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Sun Apr 14 03:06:49 2002 by Jeff Dalton
 * Copyright: (c) 2000, AIAI, University of Edinburgh
 */

package ix.iface.domain;

import ix.util.lisp.Symbol;

/**
 * Defines constants that are useful when processing "Lisp syntax"
 * domain definitions.
 */

public interface LTF_Symbols {

    static final Symbol
	S_REFINEMENT  = Symbol.intern("refinement"),
	S_NODES       = Symbol.intern("nodes"),
	S_ORDERINGS   = Symbol.intern("orderings"),
	S_CONSTRAINTS = Symbol.intern("constraints"),
	S_ISSUES      = Symbol.intern("issues"),
	S_ISSUE       = Symbol.intern("issue");

    static final Symbol
	Q_PATTERN     = Symbol.intern("?pattern"),
	Q_VALUE       = Symbol.intern("?value");

}
