/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Thu Apr  4 16:22:03 2002 by Jeff Dalton
 * Copyright: (c) 2000, AIAI, University of Edinburgh
 */

package ix.iface.domain;

import java.util.*;

import ix.util.Strings;

/**
 * An exception used to indicate a problem while parsing.
 */
public class SyntaxException extends RuntimeException {

    public SyntaxException(String message) {
	super(Strings.foldLongLine(message));
    }
}
