/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Wed Apr  3 22:59:35 2002 by Jeff Dalton
 * Copyright: (c) 2001 - 2002, AIAI, University of Edinburgh
 */

package ix.ip2;

import java.util.*;

import ix.icore.*;
import ix.util.*;
import ix.util.lisp.*;

/**
 * A specification of a test that sends a single message
 */
public class TestItem {

    protected String menuText;
    protected String toName;
    protected Sendable contents;

    public TestItem() { }

    public String getMenuText() { return menuText; }

    public void setMenuText(String menuText) {
	this.menuText = menuText;
    }

    public String getToName() { return toName; }

    public void setToName(String toName) {
	this.toName = toName;
    }

    public Sendable getContents() { return contents; }

    public void setContents(Sendable contents) {
	this.contents = contents;
    }

}
