/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Sat Jun  1 22:15:46 2002 by Jeff Dalton
 * Copyright: (c) 2002, AIAI, University of Edinburgh
 */

package ix.util.xml;

import java.io.File;

/**
 * A FileFilter that accepts only file types that indicate that
 * the file contains XML.  At present, this is only ".xml".
 * 
 */
public class XMLFileFilter extends javax.swing.filechooser.FileFilter {
    public String getDescription() { return "XML files"; }
    public boolean accept(File f) {
	String name = f.getName();
	return name.endsWith(".xml");
    }
}
